const AST = require('./ast')
const OsloError = require('./osloError')

module.exports = {
  '+': (a, b) => new AST.Number({ value: a.value + b.value }),
  '-': (a, b) => new AST.Number({ value: a.value - b.value }),
  '*': (a, b) => new AST.Number({ value: a.value * b.value }),
  '/': (a, b) => new AST.Number({ value: a.value / b.value }),
  '=': (a, b) => new AST.Boolean({ value: a.value === b.value }),
  '>': (a, b) => new AST.Boolean({ value: a.value > b.value }),
  '<': (a, b) => new AST.Boolean({ value: a.value < b.value }),
  '>=': (a, b) => new AST.Boolean({ value: a.value >= b.value }),
  '<=': (a, b) => new AST.Boolean({ value: a.value <= b.value }),
  'list': (...args) => { return new AST.List({ elements: args }) },
  'length': xs => {
    if (xs.constructor == AST.List) {
      return new AST.Number({ value: xs.elements.length })
    }

    return new OsloError({
      line: xs.line,
      message: 'length: argument is not a list'
    })
  }
}
